/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pogr1_holec;

import java.util.*;

/**
 * This class implements static methods for operations with points and edges.
 * It sorts points according to X or Y axis position and check edges  intersection
 * @author milan
 */
public class BasicGeometry {
//DATA
//METHODS
    public static double[] FindIntersectionPoint(line l1, line l2, double epsilon) {
        double x = 0;
        double y = 0;
        double[] intersectionPoint = new double[4];
        intersectionPoint[3] = 0;

        if(l1.getGeneralEquation()[1] != 0 && l1.getGeneralEquation()[1] != 0 && (l1.getGeneralEquation()[0] != 0 || l1.getGeneralEquation()[0] != 0)) {
            x = (l1.getGeneralEquation()[2]-l2.getGeneralEquation()[2])/(l2.getGeneralEquation()[0]-l1.getGeneralEquation()[0]);
            y = l2.getGeneralEquation()[0]*x + l2.getGeneralEquation()[2];
        }
        else {
            if(l1.getGeneralEquation()[1] == 0) {
                x = (-l1.getGeneralEquation()[2])/l1.getGeneralEquation()[0];
                y = l2.getGeneralEquation()[0]*x + l2.getGeneralEquation()[2];
            }
            if(l2.getGeneralEquation()[1] == 0) {
                x = (-l2.getGeneralEquation()[2])/l2.getGeneralEquation()[0];
                y = l1.getGeneralEquation()[0]*x + l1.getGeneralEquation()[2];
            }
            if(l1.getGeneralEquation()[0] == 0) {
                y = l1.getGeneralEquation()[2];
                x = (-l2.getGeneralEquation()[1]*y - l2.getGeneralEquation()[2])/l2.getGeneralEquation()[0];
                if( ((l2.getX1()>=x-epsilon && l2.getX2()<x+epsilon)||(l2.getX2()>=x-epsilon && l2.getX1()<x+epsilon)) && ((l1.getX1()>=x-epsilon && l1.getX2()<x+epsilon)||(l1.getX2()>=x-epsilon && l1.getX1()<x+epsilon)) ) {
                    if((l2.getY1()>=y-epsilon && l2.getY2()<y+epsilon)||(l2.getY2()>=y-epsilon && l2.getY1()<y+epsilon)) {
                        intersectionPoint[0] = Math.round(x);
                        intersectionPoint[1] = Math.round(y);
                        intersectionPoint[3] = 1;
                        return intersectionPoint;
                    }
                }
            }
            if(l2.getGeneralEquation()[0] == 0) {
                y = l2.getGeneralEquation()[2];
                x = (l1.getGeneralEquation()[1]*y - l1.getGeneralEquation()[2])/l2.getGeneralEquation()[0];
            }
        }

        intersectionPoint[0] = Math.round(x);
        intersectionPoint[1] = Math.round(y);

//        if( ((l2.getY1()>y+epsilon && l2.getY2()<y-epsilon)||(l2.getY2()>y+epsilon && l2.getY1()<y-epsilon)) && ((l1.getY1()>y+epsilon && l1.getY2()<y-epsilon)||(l1.getY2()>y+epsilon && l1.getY1()<y-epsilon))  )
//            if( ((l2.getX1()>x+epsilon && l2.getX2()<x-epsilon)||(l2.getX2()>x+epsilon && l2.getX1()<x-epsilon)) && ((l1.getX1()>x+epsilon && l1.getX2()<x-epsilon)||(l1.getX2()>x+epsilon && l1.getX1()<x-epsilon))  )
    if( ((l1.getY1()>y+epsilon && l1.getY2()<y-epsilon) || (l1.getY2()>y+epsilon && l1.getY1()<y-epsilon)) && ((l2.getY1()>y+epsilon && l2.getY2()<y-epsilon) || (l2.getY2()>y+epsilon && l2.getY1()<y-epsilon)) )
        intersectionPoint[3] = 1;

        return intersectionPoint;
    }

    public static point[] getPointsByY(ArrayList<line> inpLines) {
        point[] PolygonPoints = new point[inpLines.size()];
        point p = null;
        for(int i=0; i<inpLines.size(); ++i) {
            p = new point(inpLines.get(i).getX1(), inpLines.get(i).getY1(), inpLines.get(i).getZ1());
            PolygonPoints[i] = inpLines.get(i).nodes[0];
        }
        double limit;
        int index = 0;
        for(int i=0; i<PolygonPoints.length; ++i) {
            limit = -Double.MAX_VALUE;
            for(int j=i; j<PolygonPoints.length; ++j ) {
                if(PolygonPoints[j].getY() > limit) {
                    limit = PolygonPoints[j].getY();
                    index = j;
                }
            }
            p = PolygonPoints[i];
            PolygonPoints[i] = PolygonPoints[index];
            PolygonPoints[index] = p;
        }
        return PolygonPoints;
    }

    public static point[] getSetOfPointsByY(ArrayList<point> inpPoints) {
        point[] PolygonPoints = new point[inpPoints.size()];
        point p = null;
        for(int i=0; i<inpPoints.size(); ++i) {
            PolygonPoints[i] = inpPoints.get(i);
        }
        double limit;
        int index = 0;
        for(int i=0; i<PolygonPoints.length; ++i) {
            limit = -Double.MAX_VALUE;
            for(int j=i; j<PolygonPoints.length; ++j ) {
                if(PolygonPoints[j].getY() > limit) {
                    limit = PolygonPoints[j].getY();
                    index = j;
                }
            }
            p = PolygonPoints[i];
            PolygonPoints[i] = PolygonPoints[index];
            PolygonPoints[index] = p;
        }
        return PolygonPoints;
    }

    public static circle FindSmallestCircleOfSetOfPoints(ArrayList<point> inpPoints) {
        circle smallestCircle = null;
        triangle trigon = null;
        point p1 = null;
        point p2 = null;
        point p3 = null;
        int control = 0;
        double distance = 0;
        double r, norm;
        double x1 = 0;
        double y1 = 0;
        double z1 = 0;
        double x2 = 0;
        double y2 = 0;
        double z2 = 0;
        double Surface = Double.MAX_VALUE;
        line l = null;
        for(int i=0; i<inpPoints.size(); ++i) {
            x1 = inpPoints.get(i).getX();
            y1 = inpPoints.get(i).getY();
            z1 = inpPoints.get(i).getZ();
            for(int j=0; j<inpPoints.size(); ++j) {
                x2 = inpPoints.get(j).getX();
                y2 = inpPoints.get(j).getY();
                z2 = inpPoints.get(j).getZ();
                norm = Math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2));
                if(norm > distance) {
                    distance = norm;
                    p1 = inpPoints.get(i);
                    p2 = inpPoints.get(j);
                }
            }
        }
        l = new line(p1, p2);
        r = l.length/2;
        smallestCircle = new circle(l.center, r);
        control = 0;
        for(int i=0; i< inpPoints.size(); ++i) {
            if(!PointInCircle(inpPoints.get(i), l.center, r))
                control++;
        }
        if(control == 0)
            return smallestCircle;

        for(int i=0; i<inpPoints.size(); i++) {
            p1 = inpPoints.get(i);
            for(int j=0; j<inpPoints.size(); j++) {
                p2 = inpPoints.get(j);
                for(int k=0; k<inpPoints.size(); k++) {
                    if(!(i==j || j==k || i==k)) {
                        p3 = inpPoints.get(k);
                        trigon = new triangle(p1, p2, p3);
                        l = new line(p1, trigon.semiCenter);
                        if(Surface<Math.PI*l.length*l.length)
                            continue;
                        control = 0;
                        for(int m=0; m<inpPoints.size(); m++) {
                            if(!PointInCircle(inpPoints.get(m), trigon.semiCenter, l.length))
                                control++;
                        }
                        if(control == 0) {
                            Surface = Math.PI*l.length*l.length;
                            smallestCircle = new circle(trigon.semiCenter, l.length);
                        }
                    }
                }
            }    
        }
        return smallestCircle;
    }

    private static boolean PointInCircle(point p, point center, double r) {
        double x, y, Sx, Sy;
        double epsilon = 0.01;
        x = p.getX();
        y = p.getY();
        Sx = center.getX();
        Sy = center.getY();
        r += epsilon;
        if(((x-Sx)*(x-Sx)+(y-Sy)*(y-Sy))<(r*r))
            return true;
        return false;
    }
}
