/*
 * POGR1_HolecApp.java
 */

package pogr1_holec;

import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

import java.util.*;

/**
 * The main class of the application.
 */
public class POGR1_HolecApp extends SingleFrameApplication {

    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
        show(new POGR1_HolecView(this));
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of POGR1_HolecApp
     */
    public static POGR1_HolecApp getApplication() {
        return Application.getInstance(POGR1_HolecApp.class);
    }

    protected static ArrayList<java.awt.Point> listOfInputPoints = new ArrayList<java.awt.Point>();
    //protected static ArrayList<line> listOfOutputLinesConvexHull;
    //protected static ArrayList<line> listOfOutputLinesPolygon;
    //protected static ArrayList<triangle> listOfOutputTriangles;
    //protected static ArrayList<circle> listOfOutputCircles;

    protected static ArrayList<ArrayList<GO>> listOfObjects = new ArrayList<ArrayList<GO>>();

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
        launch(POGR1_HolecApp.class, args);
    }
}
