/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pogr1_holec;

import java.awt.*;
/**
 * The represantation of graphical object 'line'
 * @author milan
 */
public class line extends GO {
//Data
    public point[] nodes;
    public point center;
    public double[] vector;
    public double length;
    private double[] generalEquation;
//Methods
    public line(point A, point B) {
        nodes = new point[2];
        vector = new double[3];
        generalEquation = new double[3];
        setNodes(A, B);
        setVector(A, B);
        setGeneralEquation(A, B);
    }

    private void setVector(point p1, point p2) {
        vector[0] = p2.getX() - p1.getX();
        vector[1] = p2.getY() - p1.getY();
        vector[2] = p2.getZ() - p1.getZ();
        length = Math.sqrt(vector[0]*vector[0] + vector[1]*vector[1] + vector[2]*vector[2]);
        vector[0] = vector[0]/length;
        vector[1] = vector[1]/length;
        vector[2] = vector[2]/length;
        center = new point((p2.getX()+p1.getX())/2, (p2.getY()+p1.getY())/2, (p2.getZ()+p1.getZ())/2);
    }

    private void setNodes(point A, point B) {
        nodes[0] = A;
        nodes[1] = B;
    }

    private void setGeneralEquation(point p1, point p2) {
        if(p1.getX()-p2.getX() != 0) {
            generalEquation[0] = (p1.getY()-p2.getY())/(p1.getX()-p2.getX());
            generalEquation[1] = -1;
            generalEquation[2] = p2.getY()-p2.getX()*generalEquation[0];
        }
        else {
            generalEquation[0] = 1;
            generalEquation[1] = 0;
            generalEquation[2] = p1.getX();
        }
    }

    public double[] getGeneralEquation() {
        return generalEquation;
    }

    public double getX1() {
        return nodes[0].getX();
    }

    public double getY1() {
        return nodes[0].getY();
    }

    public double getZ1() {
        return nodes[0].getZ();
    }

    public double getX2() {
        return nodes[1].getX();
    }

    public double getY2() {
        return nodes[1].getY();
    }

    public double getZ2() {
        return nodes[1].getZ();
    }
    
    public void PaintMe(Graphics g) {
        int x1 = (int)java.lang.Math.round(nodes[0].getX());
        int y1 = (int)java.lang.Math.round(nodes[0].getY());
        int x2 = (int)java.lang.Math.round(nodes[1].getX());
        int y2 = (int)java.lang.Math.round(nodes[1].getY());

        g.drawLine(x1, y1, x2, y2);        
    }
}
